# -*- coding: utf-8 -*-
# this file is released under public domain and you can use without limitations

from general_helpers import User_helpers

#########################################################################
## Customize your APP title, subtitle and menus here
#########################################################################

response.logo = A(B('Open',SPAN('Studio')),XML('&trade;&nbsp;'),
                  _class="brand",_href="http://www.openstudioproject.com/")
response.title = ' '.join(
    word.capitalize() for word in request.application.split('_'))
response.subtitle = T('customize me!')

## read more at http://dev.w3.org/html5/markup/meta.name.html
response.meta.author = 'Edwin van de Ven <edwin@openstudioproject.com>'
response.meta.description = 'OpenStudio'
response.meta.keywords = 'web2py, python, framework'
response.meta.generator = 'Web2py Web Framework'

## your http://google.com/analytics id
response.google_analytics_id = None

#########################################################################
## this is the main application menu add/remove items as required
#########################################################################

user_helpers = User_helpers()

default_class = ''
customers_class = ''
classes_class = ''
workshops_class = ''
sp_class = ''
stats_class = ''
settings_class = ''

if request.controller == 'default':
    default_class = 'highlighted'
elif request.controller == 'customers':
    customers_class = 'highlighted'
elif request.controller == 'classes':
    classes_class = 'highlighted'
elif request.controller == 'workshops':
    workshops_class = 'highlighted'
elif request.controller == 'school_properties' or request.controller == 'teachers':
    sp_class = 'highlighted'
elif request.controller == 'stats':
    stats_class = 'highlighted'
elif request.controller == 'settings':
    settings_class = 'highlighted'

if not auth.user is None:
    user_id = auth.user.id
    # overview
    if user_helpers.check_read_permission('default', user_id):
        submenu = []
        if user_helpers.check_read_permission('default_pinboard', user_id):
            submenu.append((T('Pin board'), False, URL('default', 'pinboard')))
        if user_helpers.check_read_permission('default_subscriptions', user_id):
            submenu.append((T('Subscriptions'), False, URL('default', 'subscriptions_new')))
        if user_helpers.check_read_permission('default_dropinclasses', user_id):
            submenu.append((T('Drop in classes'), False, URL('default', 'dropinclasses')))
        if user_helpers.check_read_permission('default_trialclasses', user_id):
            submenu.append((T('Trialclasses'), False, URL('default', 'trialclasses')))
        if user_helpers.check_read_permission('default_classcards', user_id):
            submenu.append((T('Class cards'), False, URL('default', 'classcards')))
        if user_helpers.check_read_permission('default_alternativepayments', user_id):
            submenu.append((T('Alternative payments'), False, URL('default', 'alternative_payments')))
        if user_helpers.check_read_permission('default_overduepayments', user_id):
            submenu.append((T('Overdue payments'), False, URL('default', 'overdue_payments')))
        
        response.menu = [ (SPAN(T('Overview'), _class=default_class), False, URL('default', 'pinboard'), submenu) ]
    # customers
    if user_helpers.check_read_permission('customers', user_id):
        response.menu += [ (SPAN(T('Customers'), _class=customers_class), False, URL('customers', 'index')) ]
    # schedule
    if user_helpers.check_read_permission('classes', user_id):
        response.menu += [ (SPAN(T('Schedule'), _class=classes_class), False, URL('classes', 'schedule')) ]
    # workshops
    if user_helpers.check_read_permission('workshops', user_id):
        response.menu += [ (SPAN(T('Workshops'), _class=workshops_class), False, URL('workshops', 'index')) ]
    # school properties
    if user_helpers.check_read_permission('schoolproperties', user_id):
        response.menu += [ (SPAN(T('School'), _class=sp_class), False, URL('school_properties', 'index')) ]
    # statistics
    if user_helpers.check_read_permission('stats', user_id):
        if request.user_agent()['is_mobile']:
            response.menu += [
               (SPAN(T('Statistics'), _class=stats_class), False, URL('stats', 'index'))]
        else:
            response.menu += [
               (SPAN(T('Statistics'), _class=stats_class), False, URL('stats', 'index'), [
                   (T('Discovery'), False, URL('stats', 'discovery')),
                   (T('Geography'), False, URL('stats', 'geography')),
                   #(T('Attendance'), False, URL('stats', 'index'), [
                        #(T('Classes'), False, URL('stats', 'list_classes')),
                        #(T('Total by week'), False, URL('stats', 'attendance_average_year')),
                        #(T('Total by day'), False, URL('stats', 'attendance_day_year')),
                        #(T("Total by time"), False, URL('stats', 'attendance_time_year')),
                   #]),
                   (T('Revenue'), False, URL('stats', 'revenue')),
                  ]
                )]
    # settings
    if user_helpers.check_read_permission('settings', user_id):
        response.menu += [ (SPAN(T('Settings'), _class=settings_class), False, URL('settings', 'index')) ]
    # help # cannot contain more items yet.. in this version of web2py drop down menu items are forced to load in the same window 
    # https://groups.google.com/forum/#!topic/web2py/9S34_LHW2qQ
    if request.user_agent()['is_mobile']:
        response.menu += [
            (SPAN(T('Help'), False, 'http://www.openstudioproject.com/content/manual'))]
    else:
        response.menu += [
            (SPAN('', False, A("Help", _href='http://www.openstudioproject.com/content/manual', _target="_blank")))]

DEVELOPMENT_MENU = False

#########################################################################
## provide shortcuts for development. remove in production
#########################################################################

def _():
    # shortcuts
    app = request.application
    ctr = request.controller
    # useful links to internal and external resources
    response.menu += [
        (SPAN('web2py', _class='highlighted'), False, 'http://web2py.com', [
        (T('My Sites'), False, URL('admin', 'default', 'site')),
        (T('This App'), False, URL('admin', 'default', 'design/%s' % app), [
        (T('Controller'), False,
         URL(
         'admin', 'default', 'edit/%s/controllers/%s.py' % (app, ctr))),
        (T('View'), False,
         URL(
         'admin', 'default', 'edit/%s/views/%s' % (app, response.view))),
        (T('Layout'), False,
         URL(
         'admin', 'default', 'edit/%s/views/layout.html' % app)),
        (T('Stylesheet'), False,
         URL(
         'admin', 'default', 'edit/%s/static/css/web2py.css' % app)),
        (T('DB Model'), False,
         URL(
         'admin', 'default', 'edit/%s/models/db.py' % app)),
        (T('Menu Model'), False,
         URL(
         'admin', 'default', 'edit/%s/models/menu.py' % app)),
        (T('Database'), False, URL(app, 'appadmin', 'index')),
        (T('Errors'), False, URL(
         'admin', 'default', 'errors/' + app)),
        (T('About'), False, URL(
         'admin', 'default', 'about/' + app)),
        ]),
            ('web2py.com', False, 'http://www.web2py.com', [
             (T('Download'), False,
              'http://www.web2py.com/examples/default/download'),
             (T('Support'), False,
              'http://www.web2py.com/examples/default/support'),
             (T('Demo'), False, 'http://web2py.com/demo_admin'),
             (T('Quick Examples'), False,
              'http://web2py.com/examples/default/examples'),
             (T('FAQ'), False, 'http://web2py.com/AlterEgo'),
             (T('Videos'), False,
              'http://www.web2py.com/examples/default/videos/'),
             (T('Free Applications'),
              False, 'http://web2py.com/appliances'),
             (T('Plugins'), False, 'http://web2py.com/plugins'),
             (T('Layouts'), False, 'http://web2py.com/layouts'),
             (T('Recipes'), False, 'http://web2pyslices.com/'),
             (T('Semantic'), False, 'http://web2py.com/semantic'),
             ]),
            (T('Documentation'), False, 'http://www.web2py.com/book', [
             (T('Preface'), False,
              'http://www.web2py.com/book/default/chapter/00'),
             (T('Introduction'), False,
              'http://www.web2py.com/book/default/chapter/01'),
             (T('Python'), False,
              'http://www.web2py.com/book/default/chapter/02'),
             (T('Overview'), False,
              'http://www.web2py.com/book/default/chapter/03'),
             (T('The Core'), False,
              'http://www.web2py.com/book/default/chapter/04'),
             (T('The Views'), False,
              'http://www.web2py.com/book/default/chapter/05'),
             (T('Database'), False,
              'http://www.web2py.com/book/default/chapter/06'),
             (T('Forms and Validators'), False,
              'http://www.web2py.com/book/default/chapter/07'),
             (T('Email and SMS'), False,
              'http://www.web2py.com/book/default/chapter/08'),
             (T('Access Control'), False,
              'http://www.web2py.com/book/default/chapter/09'),
             (T('Services'), False,
              'http://www.web2py.com/book/default/chapter/10'),
             (T('Ajax Recipes'), False,
              'http://www.web2py.com/book/default/chapter/11'),
             (T('Components and Plugins'), False,
              'http://www.web2py.com/book/default/chapter/12'),
             (T('Deployment Recipes'), False,
              'http://www.web2py.com/book/default/chapter/13'),
             (T('Other Recipes'), False,
              'http://www.web2py.com/book/default/chapter/14'),
             (T('Buy this book'), False,
              'http://stores.lulu.com/web2py'),
             ]),
            (T('Community'), False, None, [
             (T('Groups'), False,
              'http://www.web2py.com/examples/default/usergroups'),
                        (T('Twitter'), False, 'http://twitter.com/web2py'),
                        (T('Live Chat'), False,
                         'http://webchat.freenode.net/?channels=web2py'),
                        ]),
                (T('Plugins'), False, None, [
                        ('plugin_wiki', False,
                         'http://web2py.com/examples/default/download'),
                        (T('Other Plugins'), False,
                         'http://web2py.com/plugins'),
                        (T('Layout Plugins'),
                         False, 'http://web2py.com/layouts'),
                        ])
                ]
         )]
if DEVELOPMENT_MENU: _()
