#!/usr/bin/env python

'''
    py.test test cases to test the schedule controller (schedule.py)
'''

from gluon.contrib.populate import populate

def test_holidays_index(client, web2py):
    '''
        Is the index page showing?
    '''
    url = '/schedule/holidays'
    client.get(url)
    assert client.status == 200
    assert 'Holidays' in client.text
    
def test_holiday_add(client, web2py):
    '''
        Can we add a holiday?
    '''
    url = '/schedule/holiday_add'
    client.get(url)
    assert client.status == 200
    assert 'New holiday' in client.text
    
    data = dict(Description='Kerstvakantie',
                 Startdate='2014-12-20',
                 Enddate='2014-12-25',
                 Classes=True)
    client.post(url, data=data)
    assert client.status == 200
    assert 'Holidays' in client.text # verify redirection
    assert data['Description'] in client.text
    
    assert web2py.db(web2py.db.school_holidays).count() == 1
    
def test_holiday_edit(client, web2py):
    '''
        Can we edit a holiday?
    '''
    web2py.db.school_holidays.insert(Description = 'test', 
                              Startdate = '2014-01-01',
                              Enddate = '2014-12-12',
                              Classes=True)
    web2py.db.commit()
    assert web2py.db(web2py.db.school_holidays).count() == 1
    
    url = '/schedule/holiday_edit/1'
    client.get(url)
    assert client.status == 200
    assert 'Edit holiday' in client.text
    
    data = dict(Description='Kerstvakantie',
                 Startdate='2014-12-20',
                 Enddate='2014-12-25')
    client.post(url, data=data)
    assert client.status == 200
    assert 'Holidays' in client.text # verify redirection
    assert data['Description'] in client.text
    
    assert web2py.db(web2py.db.school_holidays).count() > 0
